#ifndef GFILE_H
#define GFILE_H

#include <sys/types.h>

typedef enum {
	GENERIC_FILE_PLAIN,
	GENERIC_FILE_SPARSE,
} generic_file_t;

struct generic_file * generic_file_open( const char *filename, generic_file_t type );
struct generic_file * generic_file_create( const char *filename, generic_file_t type );
void    generic_file_delete( const char *filename );

ssize_t generic_file_read( struct generic_file *g, void *data, size_t length, size_t offset );
ssize_t generic_file_write( struct generic_file *g, const void *data, size_t length, size_t offset );
int     generic_file_commit( struct generic_file *g );
void    generic_file_close( struct generic_file *g );

#endif
