/*
dttools is Copyright (C) 2002 Douglas Thain
This software is released under the GNU General Public License.
See the file COPYING for details.
*/


#ifndef ITABLE_H
#define ITABLE_H

struct itable * itable_create( int buckets );
void itable_delete( struct itable *h );

typedef int (*itable_op_t) ( struct itable *h, int key, void *item, void *arg );

int itable_insert( struct itable *h, int key, const void *value, void **old );
void * itable_lookup( struct itable *h, int key );
void * itable_remove( struct itable *h, int key );
int itable_iterate( struct itable *h, itable_op_t, void *arg );

#endif
