/*
dttools is Copyright (C) 2002 Douglas Thain
This software is released under the GNU General Public License.
See the file COPYING for details.
*/

#ifndef MEMORY_MANAGER_H
#define MEMORY_MANAGER_H

#include "int_sizes.h"

typedef UINT64_T msize_t;
#define MSIZE_FORMAT UINT64_FORMAT

struct memory_manager * memory_manager_create( msize_t max );
void                    memory_manager_delete( struct memory_manager *mm );
void                    memory_manager_alloc( struct memory_manager *mm, msize_t size );
void                    memory_manager_free( struct memory_manager *mm, msize_t size );
void                    memory_manager_set( struct memory_manager *mm, msize_t max );
void                    memory_manager_get( struct memory_manager *mm, msize_t *max, msize_t *inuse );
void                    memory_manager_add( struct memory_manager *mm, msize_t size );

#endif
