/*
dttools is Copyright (C) 2002 Douglas Thain
This software is released under the GNU General Public License.
See the file COPYING for details.
*/


#ifndef MULTI_HASH_TABLE_H
#define MULTI_HASH_TABLE_H

#include "hash_table.h"

struct multi_hash_table * multi_hash_table_create( int buckets, hash_func_t func );
void multi_hash_table_delete( struct multi_hash_table *h );

int multi_hash_table_push_head( struct multi_hash_table *h, const char *key, const void *value );
void * multi_hash_table_peek_head( struct multi_hash_table *h, const char *key );
void * multi_hash_table_pop_head( struct multi_hash_table *h, const char *key );

int multi_hash_table_push_tail( struct multi_hash_table *h, const char *key, const void *value );
void * multi_hash_table_peek_tail( struct multi_hash_table *h, const char *key );
void * multi_hash_table_pop_tail( struct multi_hash_table *h, const char *key );

#endif
