/*
dttools is Copyright (C) 2002 Douglas Thain
This software is released under the GNU General Public License.
See the file COPYING for details.
*/


#include "sort_dir.h"

#include <dirent.h>
#include <string.h>
#include <stdlib.h>
#include <dirent.h>

int sort_dir( const char *dirname, char ***list, int (*sort) ( const void *a, const void *b ) )
{
	DIR *dir=0;
	struct dirent *d;
	int size=10;
	int used=0;
	char *s;
	int i;

	*list = malloc(size*sizeof(char*));
	if(!*list) goto failure;

	dir = opendir(dirname);
	if(!dir) goto failure;

	while( (d = readdir(dir)) ) {
		if(used>=size) {
			size *=2;
			*list = realloc(*list,sizeof(char*)*size);
			if(!*list) goto failure;
		}

		s = strdup(d->d_name);
		if(!s) goto failure;

		(*list)[used++] = s;
	}

	if(sort) {
		qsort( *list, used, sizeof(char*), sort );
	}

	closedir(dir);
	(*list)[used] = 0;
	return 1;

	failure:
	if(*list) {
		for(i=0;i<used;i++) {
			if((*list)[i]) free((*list)[i]);
		}
		free(*list);
		*list = 0;
	}
	if(dir) closedir(dir);
	return 0;
}

